obj/footstep
	icon = null
	layer = OBJ_LAYER + 0.2


turf/fixture
	var/hintstate //the "action icon" that will show on HUD underneath the main window
	name = "" //don't show text tip on mouseover
	layer = TURF_LAYER + 0.1
	icon = 'fixturehints.dmi'


	proc/Dispatch(mob/player/M)
		//this is a stub that determines the fixture's effects when used;
		//each subtype will override it to handle it appropriately.


	exit
		var/exitdir
		var/obj/footstep/footstep


		New()
			. = ..()
			//the footstep object will flicker when there are sounds in adjacent room
			footstep = new(src)

			hintstate = icon_state
			//in the map editor, each exit is placed with a directional icon state
			//(u, d, l, r). But we want these to be invisible at runtime, so we use exitdir
			//to remember the chosen direction.
			exitdir = icon_state
			icon_state = null


		Dispatch(mob/player/M)
			//find the area the exit points to, then the specific turf, then go there
			var/area/E = loc:exits[exitdir]
			var/turf/T = E.arrivals[loc]
			M.Move(T, M.dir)


		proc/MakeFootstep()
			//display a footstep flicker
			var/area/E = loc:exits[exitdir]
			var/turf/T = E.arrivals[loc]
			flick('footsteps.dmi', T:footstep)


	swap
		icon_state = "swap"


		New()
			. = ..()
			hintstate = icon_state
			icon_state = "cabinet"


		Dispatch(mob/player/M)
			var/obj/item/I = locate() in src
			M:SwapItemFor(I)


	alarm
		//the alarm serves no official purpose, but it's cool
		icon_state = "alarm"
		var/usable = 1


		New()
			. = ..()
			hintstate = icon_state
			icon_state = "fire alarm"


		Dispatch(mob/player/M)
			if(!usable) return
			usable = 0
			spawn(ALARM_DELAY) usable = 1

			world << alarmSound
			world << GetAlarmText("Someone set off the alarm in [M.loc:loc]!")

