obj/letter
	icon = 'letters.dmi'
	pixel_y = 11
	layer = FLY_LAYER


//overlay a text string (more than 8 chars will be truncated) on a mob
mob/player/proc/OverlayText(mystr)
	overlays.len = 0

	mystr = copytext(lowertext(mystr), 1, 9)
	for(var/i in 1 to length(mystr))
		var/curchar = copytext(mystr, i, i + 1)
		var/obj/letter/O = new()

		//this is a workaround; an icon state named with a space
		//automatically becomes null-named in the editor
		if(curchar == " ") curchar = "_"

		O.icon_state = curchar
		O.pixel_x = 4 * (i - 1)
		overlays += O
